unit PhylBig;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,GR32, GR32_Image,GR32_Layers, StdCtrls,jpeg, ExtDlgs;

type
  TFormBig = class(TForm)
    ImgBig: TImgView32;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    ScrolZoom: TScrollBar;
    Button1: TButton;
    EnrImage: TButton;
    SaveDialog: TSaveDialog;
    PanelBoutons: TPanel;
    OK: TButton;
    Annule: TButton;
    SelTout: TButton;
    Button2: TButton;
    procedure AgrandirImage(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure ScrolZoomChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SelToutClick(Sender: TObject);
    procedure EnrImageClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Dclarations prives }
    procedure ChargeLangue;
  public
    { Dclarations publiques }
    Delimiter:boolean;
    Cadre:TRubberbandLayer;
    ImageRetour:TBitmap32;
    HCadre,BCadre,GCadre,DCadre:integer;
    procedure ChangeCadre(Sender:Tobject);
  end;

var
  FormBig: TFormBig;

implementation

{$R *.DFM}
uses Donnees,math,utils,PhylMain,GestionTextes;   //

procedure TFormBig.AgrandirImage(Sender: TObject);
begin
  //BoundsRect:=TImage(Sender).BoundsRect;
  //BigImage.Picture:=TImage(Sender).Picture;
  //Show;
end;

procedure TFormBig.FormCreate(Sender: TObject);
//Var
 // RectLoc:TFloatRect;
begin
  Cadre:=TRubberbandLayer.Create(ImgBig.Layers);
  Cadre.Scaled:=True;
  Cadre.OnUserChange:=ChangeCadre;
{  RectLoc.Top:=0;
  RectLoc.Bottom:=ImgBig.Bitmap.Height-2;
  RectLoc.Left:=0;
  RectLoc.Right:=ImgBig.Bitmap.Width-2;
  Cadre.Location:=RectLoc;}
  Cadre.Visible:=True;
  ImageRetour:=TBitmap32.Create;
  ChargeLangue;
end;
procedure TFormBig.ChangeCadre(Sender:Tobject);
Var
 G,D,H,B:single;
 Rectangl:TFloatRect;
begin
  G:=Cadre.Location.Left;
  D:=Cadre.Location.Right;
  H:=Cadre.Location.Top;
  B:=Cadre.Location.Bottom;
  If G<0 then G:=0;
  if G>(ImgBig.Bitmap.Width-10)then G:=ImgBig.Bitmap.Width-10;
  If D<(G+10) then D:=(G+10);
  if D>(ImgBig.Bitmap.Width)then D:=ImgBig.Bitmap.Width;
  If H<0 then H:=0;
  if H>(ImgBig.Bitmap.Height-10)then H:=ImgBig.Bitmap.Height-10;
  If B<(H+10) then B:=(H+10);
  if B>(ImgBig.Bitmap.Height)then B:=ImgBig.Bitmap.Height;
  Rectangl:=FloatRect(G,H,D,B);
  Cadre.Location:=Rectangl;
end;

procedure TFormBig.OKClick(Sender: TObject);
Var
  Rectang:TRect;
  RectCop:TRect;
begin
  Rectang:=MakeRect(Cadre.Location);
  RectCop:=MakeRect(0,0,Rectang.Right-Rectang.Left,Rectang.Bottom-Rectang.Top);
  ImageRetour.SetSize(RectCop.Right,RectCop.Bottom);
  ImgBig.Bitmap.DrawTo(ImageRetour,RectCop,Rectang);
  ModalResult:=mrOK;
end;

procedure TFormBig.ScrolZoomChange(Sender: TObject);
begin
  ImgBig.Scale:=ScrolZoom.Position/10;
end;

procedure TFormBig.Button1Click(Sender: TObject);
begin
  ImgBig.scale:=1;
end;

procedure TFormBig.FormActivate(Sender: TObject);
Var
  RectLoc:TFloatRect;
  RectImgBig:TRect;
begin
  ImgBig.OffsetHorz:=0;
  ImgBig.OffsetVert:=0;
  RectImgBig:=ImgBig.GetViewportRect;
  RectLoc.Top:=0;
  RectLoc.Bottom:=Min(ImgBig.Bitmap.Height,RectImgBig.Bottom);
  RectLoc.Left:=0;
  RectLoc.Right:=Min(ImgBig.Bitmap.Width,RectImgBig.Right);
  Cadre.Location:=RectLoc;
  PanelBoutons.Left:=Panel1.Width-PanelBoutons.Width-5;
end;

procedure TFormBig.SelToutClick(Sender: TObject);
Var
  RectLoc:TFloatRect;
begin
  RectLoc.Top:=0;
  RectLoc.Bottom:=ImgBig.Bitmap.Height;
  RectLoc.Left:=0;
  RectLoc.Right:=ImgBig.Bitmap.Width;
  Cadre.Location:=RectLoc;
end;

procedure TFormBig.EnrImageClick(Sender: TObject);
Var
  Rectang:TRect;
  RectCop:TRect;
  NomFichier,extension:string;
  image_temp_J:TBitmap;
  JPEGImage:TJPEGImage;
begin
  FormStyle:=fsNormal;
  SaveDialog.InitialDir:=GetMesDocuments;
  if SaveDialog.Execute then
    begin
      Rectang:=MakeRect(Cadre.Location);
      RectCop:=MakeRect(0,0,Rectang.Right-Rectang.Left,Rectang.Bottom-Rectang.Top);
      ImageRetour.SetSize(RectCop.Right,RectCop.Bottom);
      ImgBig.Bitmap.DrawTo(ImageRetour,RectCop,Rectang);
      NomFichier:=SaveDialog.FileName;
      Extension:=UpperCase(ExtractFileExt(NomFichier));
      If Extension='.BMP' then ImageRetour.SaveToFile(NomFichier)
      else if Extension='.JPG' then
        begin
          image_temp_J:=TBitmap.Create;
          JPEGImage:=TJPEGImage.Create;
          With JPEGImage do
            begin
              try
                image_temp_J.Assign(ImageRetour);
                Assign(image_temp_J);
                CompressionQuality:=90;
                SaveToFile(NomFichier);
              finally
                free;
                image_temp_J.Free;
              end;
            end;
        end;
    end;
  FormStyle:=fsStayOnTop;
end;

procedure TFormBig.Button2Click(Sender: TObject);
begin
  ImgBig.Bitmap.Rotate90;
  ChangeCadre(Self);
end;

procedure TFormBig.FormResize(Sender: TObject);
begin
  PanelBoutons.Left:=Panel1.Width-PanelBoutons.Width-5;
end;
procedure TFormBig.ChargeLangue;
begin
  Caption:=C_FormBig; // Dlimiter la zone  copier ou  imprimer
  Label2.Caption:=C_FormBigLabel2; // Zoom
  EnrImage.Caption:=C_FormBigEnrImage; // Enregistrer la slection dans un fichier d'image
  Annule.Caption:=C_AffTabCodAnnuleCouleur; // Annuler
  SelTout.Caption:=C_FormBigSelTout; // Tout slectionner
  Button2.Caption:=C_FormBigButton2; // Rotation 90
  SaveDialog.Filter:=Filt_FormBigSaveDialog; // image Jpeg|*.jpg|image Bmp|*.bmp
  SaveDialog.Title:=Tit_FormBigSaveDialog; // Enregistrement de l'image
end;

end.
